
///////////////////////////////////////////////////////////////////////////////
//// File: singular_value_decomposition.h                                       //
//// Contents:                                                                  //
////    Singular_Value_Decomposition                                            //
////    Singular_Value_Decomposition_Solve                                      //
////    Singular_Value_Decomposition_Inverse                                    //
//////////////////////////////////////////////////////////////////////////////////
//
#include <string.h>              // required for memcpy()
#include <float.h>               // required for DBL_EPSILON
#include <math.h>                // required for fabs(), sqrt();

#define MAX_ITERATION_COUNT 30   // Maximum number of iterations

////                        Internally Defined Routines 
static void Householders_Reduction_to_Bidiagonal_Form(double* A, int nrows,
    int ncols, double* U, double* V, double* diagonal, double* superdiagonal );
static int  Givens_Reduction_to_Diagonal_Form( int nrows, int ncols,
    double* U, double* V, double* diagonal, double* superdiagonal );
static void Sort_by_Decreasing_Singular_Values(int nrows, int ncols,
    double* singular_value, double* U, double* V);


